/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 800
#ifdef HAVE_CONFIG_H
#line 800
# include <config.h>
#line 800
#endif
#line 800
#include <sys/types.h>
#line 800

#line 800
#include "mailfromd.h"
#line 800
#include "prog.h"
#line 800
#include "builtin.h"
#line 800

#line 175 "db.bi"
static size_t debug_handle;
#line 800 "db.bi"

#line 660 "../../src/builtin/snarf.m4"

#line 1 "db.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#define DEFAULT_DB_MODE 0640
#include <fnmatch.h>
#include "mf-dbm.h"

struct db_prop {                /* Database properties */
	char *pat;              /* Database name pattern */
	mode_t mode;            /* File mode */
	int null;               /* Null byte */
};

static mu_list_t db_prop_list;

static int
db_prop_compare(const void *item, const void *data)
{
	const struct db_prop *prop = item;
	const char *name = data;
	return strcmp(prop->pat, name);
}

static int
strtomode(char *str, mode_t *pmode)
{
	mode_t mode = 0;
	struct { char c; unsigned mask; } modetab[] = {
		{ 'r', S_IRUSR },
		{ 'w', S_IWUSR },
		{ 'x', S_IXUSR },
		{ 'r', S_IRGRP },
		{ 'w', S_IWGRP },
		{ 'x', S_IXGRP },
		{ 'r', S_IROTH },
		{ 'w', S_IWOTH },
		{ 'x', S_IXOTH },
		{ 0 }
	};
	int i;

	for (i = 0; modetab[i].c; i++) {
		if (!str[i])
			return i + 1;
		if (str[i] == modetab[i].c)
			mode |= modetab[i].mask;
		else if (str[i] != '-')
			return i + 1;
	}
	if (str[i])
		return i + 1;
	*pmode = mode;
	return 0;
}

/* #pragma dbprop <name> [null] [mode] */
#line 70 "db.bi"

#line 70
static void _pragma_dbprop (int argc, char **argv, const char *text)
#line 70

{
	int null = 0;
	mode_t mode = DEFAULT_DB_MODE;
	struct db_prop *prop;
	int rc;
	char *pat;

	--argc;
	pat = *++argv;
	
	while (--argc) {
		char *p = *++argv;

		if (strcmp(p, "null") == 0)
			null = 1;
		else if (c_isdigit(*p)) {
			unsigned long n = strtoul(p, &p, 8);
			if (*p || (mode = n) != n) {
				parse_error(_("bad numeric file mode"));
				return;
			}
		} else if (rc = strtomode(p, &mode)) {
			parse_error(_("bad symbolic file mode (near %s)"),
				    p + rc - 1);
			return;
		}
	}

	if (!db_prop_list) {
		rc = mu_list_create(&db_prop_list);
		if (rc) {
			parse_error(_("cannot create list: %s"),
				    mu_strerror(rc));
			return;
		}
		mu_list_set_comparator(db_prop_list, db_prop_compare);
	}

	if (mu_list_locate(db_prop_list, pat, (void**) &prop)) {
		prop = xmalloc(sizeof(*prop));
		prop->pat = xstrdup(pat);
		rc = mu_list_append(db_prop_list, prop);
		if (rc) {
			parse_error(_("Cannot create list: %s"),
				    mu_strerror(rc));
			return;
		}
	}
	prop->mode = mode;
	prop->null = null;
}

const struct db_prop *
db_prop_lookup(const char *name)
{
	mu_iterator_t itr;
	const struct db_prop *found = NULL;
	
	if (db_prop_list
	    && mu_list_get_iterator(db_prop_list, &itr) == 0) {
		for (mu_iterator_first(itr);
		     !mu_iterator_is_done(itr);
		     mu_iterator_next(itr)) {
			const struct db_prop *p;
			mu_iterator_current(itr, (void**)&p);
			if (strcmp(p->pat, name) == 0) {
				found = p;
				break;
			} else if (fnmatch(p->pat, name, 0) == 0)
				found = p;
		}
		mu_iterator_destroy(&itr);
	}
	return found;	
}


#define LOOKUP_NULL_BYTE 0x1
#define LOOKUP_TEST_ONLY 0x2

static int
dbmap_lookup(eval_environ_t env, char *dbname, const char *keystr,
	     const char *defval, int flags)
{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;

	if (!defval)
		defval = "";
	if (mf_dbm_open(dbname, &db, MU_STREAM_READ, 0, NULL))
			env_throw_bi(env, mfe_dbfailure, NULL, _("mf_dbm_open(%s) failed: %s"),dbname,mf_dbm_strerror());
#line 167

	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(key) = (void*) keystr;
	MF_DATUM_SIZE(key) = strlen(keystr);
	if (flags & LOOKUP_NULL_BYTE)
		MF_DATUM_SIZE(key)++;
	rc = mf_dbm_fetch(&db, key, &contents) == 0;
	
#line 175 "db.bi"

#line 175
mu_debug(debug_handle, MU_DEBUG_TRACE5,("Looking up %s: %s", keystr, rc ? "true" : "false"));
#line 177
	if (flags & LOOKUP_TEST_ONLY) 
		push(env, (STKVAL)rc);
	else {
		if (!rc) {
			if (defval)
				pushs(env, (STKVAL)defval);
			else
				push(env, 0);
		} else if (((char*)MF_DATUM_PTR(contents))[MF_DATUM_SIZE(contents)-1]) {
			size_t off;
			size_t len = MF_DATUM_SIZE(contents);
			char *s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
			memcpy(s, MF_DATUM_PTR(contents), len);
			s[len] = 0;
			push(env, (STKVAL) off);
		} else
			pushs(env, MF_DATUM_PTR(contents));
	}
	mf_dbm_datum_free(&contents);
	mf_dbm_close(&db);
	return rc;
}

void
#line 200
bi_dbmap(eval_environ_t env)
#line 200

#line 200 "db.bi"
{
#line 200
	
#line 200

#line 200
long __bi_argcnt;
#line 200
char * dbname;
#line 200
        char * key;
#line 200
        long  null;
#line 200
        
#line 200
get_string_arg(env, 1, &dbname);
#line 200
        get_string_arg(env, 2, &key);
#line 200
        get_numeric_arg(env, 3, &null);
#line 200
        
#line 200
get_numeric_arg(env, 0, &__bi_argcnt);
#line 200
        adjust_stack(env, __bi_argcnt + 1);
#line 200

#line 200
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 200
		prog_trace(env, "dbmap %s %s %lu",dbname, key, ((__bi_argcnt > 2) ? null : 0));;
#line 200

{
	const struct db_prop *prop = db_prop_lookup(dbname);
	dbmap_lookup(env, dbname, key, NULL,
		     LOOKUP_TEST_ONLY | 
		         (((__bi_argcnt > 2) ? null : prop && prop->null)
			   ? LOOKUP_NULL_BYTE : 0));
}
}

void
#line 210
bi_dbget(eval_environ_t env)
#line 210

#line 210 "db.bi"
{
#line 210
	
#line 210

#line 210
long __bi_argcnt;
#line 210
char * dbname;
#line 210
        char * key;
#line 210
        char * defval;
#line 210
        long  null;
#line 210
        
#line 210
get_string_arg(env, 1, &dbname);
#line 210
        get_string_arg(env, 2, &key);
#line 210
        get_string_arg(env, 3, &defval);
#line 210
        get_numeric_arg(env, 4, &null);
#line 210
        
#line 210
get_numeric_arg(env, 0, &__bi_argcnt);
#line 210
        adjust_stack(env, __bi_argcnt + 1);
#line 210

#line 210
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 210
		prog_trace(env, "dbget %s %s %s %lu",dbname, key, ((__bi_argcnt > 2) ? defval : ""), ((__bi_argcnt > 3) ? null : 0));;

{
	const struct db_prop *prop = db_prop_lookup(dbname);
	dbmap_lookup(env, dbname, key, 
                     ((__bi_argcnt > 2) ? defval : 0), 
		     ((__bi_argcnt > 3) ? null : prop && prop->null)
		      ? LOOKUP_NULL_BYTE : 0);
}
}

void
#line 221
bi_dbput(eval_environ_t env)
#line 221

#line 221 "db.bi"
{
#line 221
	
#line 221

#line 221
long __bi_argcnt;
#line 221
char * dbname;
#line 221
        char * keystr;
#line 221
        char * value;
#line 221
        long  null;
#line 221
        long  mode;
#line 221
        
#line 221
get_string_arg(env, 1, &dbname);
#line 221
        get_string_arg(env, 2, &keystr);
#line 221
        get_string_arg(env, 3, &value);
#line 221
        get_numeric_arg(env, 4, &null);
#line 221
        get_numeric_arg(env, 5, &mode);
#line 221
        
#line 221
get_numeric_arg(env, 0, &__bi_argcnt);
#line 221
        adjust_stack(env, __bi_argcnt + 1);
#line 221

#line 221
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 221
		prog_trace(env, "dbput %s %s %s %lu %lu",dbname, keystr, value, ((__bi_argcnt > 3) ? null : 0), ((__bi_argcnt > 4) ? mode : 0));;

{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;
	const struct db_prop *prop = db_prop_lookup(dbname);
	
	if (mf_dbm_open(dbname, &db, MU_STREAM_RDWR,
			((__bi_argcnt > 4) ? mode : (prop ? prop->mode : DEFAULT_DB_MODE)),
			NULL))
			env_throw_bi(env, mfe_dbfailure, "dbput", _("mf_dbm_open(%s) failed: %s"),dbname,mf_dbm_strerror());
#line 237
	memset(&key, 0, sizeof key);
	MF_DATUM_PTR(key) = keystr;
	MF_DATUM_SIZE(key) = strlen(keystr);
	if (((__bi_argcnt > 3) ? null : prop && prop->null))
		MF_DATUM_SIZE(key)++;

	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(contents) = value;
	MF_DATUM_SIZE(contents) = strlen(value) + 1;
	
	rc = mf_dbm_insert(&db, key, contents, 1);
	mf_dbm_close(&db);
		if (!(rc == 0))
#line 249
			env_throw_bi(env, mfe_dbfailure, "dbput", _("failed to insert data to %s: %s %s: %s"),dbname,keystr,value,mf_dbm_strerror())
#line 255
;
}
}

void
#line 259
bi_dbdel(eval_environ_t env)
#line 259

#line 259 "db.bi"
{
#line 259
	
#line 259

#line 259
long __bi_argcnt;
#line 259
char * dbname;
#line 259
        char * keystr;
#line 259
        long  null;
#line 259
        long  mode;
#line 259
        
#line 259
get_string_arg(env, 1, &dbname);
#line 259
        get_string_arg(env, 2, &keystr);
#line 259
        get_numeric_arg(env, 3, &null);
#line 259
        get_numeric_arg(env, 4, &mode);
#line 259
        
#line 259
get_numeric_arg(env, 0, &__bi_argcnt);
#line 259
        adjust_stack(env, __bi_argcnt + 1);
#line 259

#line 259
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 259
		prog_trace(env, "dbdel %s %s %lu %lu",dbname, keystr, ((__bi_argcnt > 2) ? null : 0), ((__bi_argcnt > 3) ? mode : 0));;

{
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	int rc;
	const struct db_prop *prop = db_prop_lookup(dbname);
	
	if (mf_dbm_open(dbname, &db, MU_STREAM_RDWR,
			((__bi_argcnt > 3) ? mode : (prop ? prop->mode : DEFAULT_DB_MODE)),
			NULL))
			env_throw_bi(env, mfe_dbfailure, "dbdel", _("mf_dbm_open(%s) failed: %s"),dbname,mf_dbm_strerror());
#line 274
	memset(&key, 0, sizeof key);
	MF_DATUM_PTR(key) = keystr;
	MF_DATUM_SIZE(key) = strlen(keystr);
	if (((__bi_argcnt > 2) ? null : prop && prop->null))
		MF_DATUM_SIZE(key)++;
	rc = mf_dbm_delete(&db, key);
	mf_dbm_close(&db);
		if (!(rc == 0))
#line 281
			env_throw_bi(env, mfe_dbfailure, "dbdel", _("failed to delete data `%s' from `%s': %s"),keystr,dbname,mf_dbm_strerror())
#line 286
;
}
}


#define NUMDB 128

struct db_tab {
	int used;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
};

static void *
alloc_db_tab()
{
	return xcalloc(NUMDB, sizeof(struct db_tab));
}

static void
close_db_tab(struct db_tab *dbt)
{
	if (dbt->used) {
		mf_dbm_datum_free(&dbt->key);
		mf_dbm_close(&dbt->db);
		dbt->used = 0;
	}
}

static void
destroy_db_tab(void *data)
{
	int i;
	struct db_tab *db = data;
	for (i = 0; i < NUMDB; i++) 
		close_db_tab(db + i);
	free(db);
}


#line 325

#line 325
static int DBTAB_id;
#line 325 "db.bi"
;

static int
new_db_tab(struct db_tab *dbt)
{
	int i;
	for (i = 0; i < NUMDB; i++)
		if (!dbt[i].used) {
			dbt[i].used = 1;
			return i;
		}
	return -1;
}
			


void
#line 341
bi_dbfirst(eval_environ_t env)
#line 341

#line 341 "db.bi"
{
#line 341
	
#line 341

#line 341

#line 341
char * dbname;
#line 341
        
#line 341
get_string_arg(env, 0, &dbname);
#line 341
        
#line 341

#line 341
        adjust_stack(env, 1);
#line 341

#line 341
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 341
		prog_trace(env, "dbfirst %s",dbname);;
#line 341

{
	int rc;
	int n;
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id);
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	
	if (mf_dbm_open(dbname, &db, MU_STREAM_READ, 0, NULL))
			env_throw_bi(env, mfe_dbfailure, "dbfirst", _("mf_dbm_open(%s) failed: %s"),dbname,mf_dbm_strerror());
#line 354
	rc = mf_dbm_firstkey(&db, &key);
		if (!(rc == 0))
#line 355
			env_throw_bi(env, mfe_dbfailure, "dbfirst", _("mf_dbm_firstkey failed: %s"),mf_dbm_strerror())
#line 357
;
	n = new_db_tab(dbt);
		if (!(n >= 0))
#line 359
			env_throw_bi(env, mfe_failure, "dbfirst", _("no more database entries available"))
#line 361
;
	dbt += n;
	dbt->db = db;
	dbt->key = key;
	
#line 365
do {
#line 365
  push(env, (STKVAL) (n));
#line 365
  return;
#line 365
} while (0);
}
}

void
#line 369
bi_dbnext(eval_environ_t env)
#line 369

#line 369 "db.bi"
{
#line 369
	
#line 369

#line 369

#line 369
long  dn;
#line 369
        
#line 369
get_numeric_arg(env, 0, &dn);
#line 369
        
#line 369

#line 369
        adjust_stack(env, 1);
#line 369

#line 369
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 369
		prog_trace(env, "dbnext %lu",dn);;
#line 369

{
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id) + dn;
	MF_DBM_DATUM nextkey;
	int rc;
	
		if (!(dn >= 0 && dn < NUMDB && dbt->used))
#line 375
			env_throw_bi(env, mfe_range, "dbnext", _("invalid database descriptor"))
#line 377
;

	rc = mf_dbm_nextkey(&dbt->db, dbt->key, &nextkey);
	if (rc) {
		close_db_tab(dbt);
		
#line 382
do {
#line 382
  push(env, (STKVAL) (0));
#line 382
  return;
#line 382
} while (0);
	}
	mf_dbm_datum_free(&dbt->key);
	dbt->key = nextkey;
	
#line 386
do {
#line 386
  push(env, (STKVAL) (1));
#line 386
  return;
#line 386
} while (0);
}
}

void
#line 390
bi_dbkey(eval_environ_t env)
#line 390

#line 390 "db.bi"
{
#line 390
	
#line 390

#line 390

#line 390
long  dn;
#line 390
        
#line 390
get_numeric_arg(env, 0, &dn);
#line 390
        
#line 390

#line 390
        adjust_stack(env, 1);
#line 390

#line 390
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 390
		prog_trace(env, "dbkey %lu",dn);;
#line 390

{
	size_t off, len;
	char *s;
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id) + dn;
	
		if (!(dn >= 0 && dn < NUMDB && dbt->used))
#line 396
			env_throw_bi(env, mfe_range, "dbkey", _("invalid database descriptor"))
#line 398
;
	
	len = MF_DATUM_SIZE(dbt->key);
	s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
	memcpy(s, MF_DATUM_PTR(dbt->key), len);
	s[len] = 0;
	
#line 404
do {
#line 404
  push(env, (STKVAL) (off));
#line 404
  return;
#line 404
} while (0);
}
}

void
#line 408
bi_dbvalue(eval_environ_t env)
#line 408

#line 408 "db.bi"
{
#line 408
	
#line 408

#line 408

#line 408
long  dn;
#line 408
        
#line 408
get_numeric_arg(env, 0, &dn);
#line 408
        
#line 408

#line 408
        adjust_stack(env, 1);
#line 408

#line 408
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 408
		prog_trace(env, "dbvalue %lu",dn);;
#line 408

{
	int rc;
	size_t off, len;
	char *s;
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id) + dn;
	MF_DBM_DATUM contents;
	
		if (!(dn >= 0 && dn < NUMDB && dbt->used))
#line 416
			env_throw_bi(env, mfe_range, "dbvalue", _("invalid database descriptor"))
#line 418
;

	memset(&contents, 0, sizeof contents);
	rc = mf_dbm_fetch(&dbt->db, dbt->key, &contents);
		if (!(rc == 0))
#line 422
			env_throw_bi(env, mfe_dbfailure, "dbvalue", _("key not found: %s"),mf_dbm_strerror())
#line 425
;
	
	len = MF_DATUM_SIZE(contents);
	s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
	memcpy(s, MF_DATUM_PTR(contents), len);
	s[len] = 0;
	mf_dbm_datum_free(&contents);
	
#line 432
do {
#line 432
  push(env, (STKVAL) (off));
#line 432
  return;
#line 432
} while (0);
}
}


enum greylist_semantics
{
	greylist_traditional,
	greylist_ct
};

static enum greylist_semantics greylist_semantics = greylist_traditional;

/* #pragma greylist {traditional|gray|ct|con-tassios}*/
#line 446 "db.bi"

#line 446
static void _pragma_greylist (int argc, char **argv, const char *text)
#line 446

{
	if (strcmp(argv[1], "traditional") == 0
	    || strcmp(argv[1], "gray") == 0)
		greylist_semantics = greylist_traditional;
	else if (strcmp(argv[1], "ct") == 0
		 || strcmp(argv[1], "con-tassios") == 0)
		greylist_semantics = greylist_ct;
	else
		/* TRANSLATORS: Do not translate keywords:
		   traditional, gray, ct, con-tassios */
		parse_error(_("unknown semantics; allowed values are: "
			      "traditional (or gray) and "
			      "ct (or con-tassios)"));
}

/* FIXME: Duplicated in lib/cache.c */
static char *
format_timestr(time_t timestamp, char *timebuf, size_t bufsize)
{
	struct tm tm;
	gmtime_r(&timestamp, &tm);
	strftime(timebuf, bufsize, "%c", &tm);
	return timebuf;
}

static size_t greylist_seconds_left_loc
#line 472 "db.bi"
;

/* The traditional (aka gray's) greylist implementation: the greylist
   database keeps the time the greylisting was activated.
 */
static int
do_greylist_traditional(eval_environ_t env, char *email, long interval)
{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;
	int readonly;
	time_t now;

	rc = mf_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
        	if (!(rc == 0))
#line 489
			env_throw_bi(env, mfe_dbfailure, NULL, _("mf_dbm_open(%s) failed: %s"),greylist_format->dbname,mf_dbm_strerror())
;
	
	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(key) = email;
	MF_DATUM_SIZE(key) = strlen(email)+1;

	time(&now);
	if (mf_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp, diff;

			if (!(MF_DATUM_SIZE(contents) == sizeof timestamp))
#line 501
			env_throw_bi(env, mfe_dbfailure, NULL, _("greylist database %s has wrong data size"),greylist_format->dbname)
#line 504
;
		
		timestamp = *(time_t*) MF_DATUM_PTR(contents);
		diff = now - timestamp;

		if (mu_debug_level_p(debug_handle, MU_DEBUG_TRACE5)) {
			char timebuf[32];
			mu_debug_log("%s entered greylist database on %s, "
				     "%ld seconds ago",
				     email,
				     format_timestr(timestamp, timebuf,
						    sizeof timebuf),
				     (long) diff);
		}

		if (diff < interval) {
			diff = interval - diff;

			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (diff);
			
			
#line 524

#line 524
mu_debug(debug_handle, MU_DEBUG_TRACE6,("%s still greylisted (for %lu sec.)",
			          email,
			          (unsigned long) diff));
#line 528
			rc = 1;
		} else if (diff > greylist_format->expire_interval) {
			
#line 530

#line 530
mu_debug(debug_handle, MU_DEBUG_TRACE6,("greylist record for %s expired", email));
#line 532
			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
			if (!readonly) {
				memcpy(MF_DATUM_PTR(contents),
				       &now, sizeof now);
				if (mf_dbm_insert(&db, key, contents, 1))
					mu_error(_("cannot insert datum `%-.*s' in "
						   "greylist database %s: %s"),
			                         MF_DATUM_SIZE(key),
						 (char*)MF_DATUM_PTR(key),
						 greylist_format->dbname,
	                                         mf_dbm_strerror());
			} else
				
#line 544

#line 544
mu_debug(debug_handle, MU_DEBUG_TRACE6,("database opened in readonly mode: "
			  	          "not updating"));
#line 547
			rc = 1;
		} else {
			
#line 549

#line 549
mu_debug(debug_handle, MU_DEBUG_TRACE6,("%s finished greylisting period", email));
#line 551
			rc = 0;
		}
		mf_dbm_datum_free(&contents);
	} else if (!readonly) {
		
#line 555

#line 555
mu_debug(debug_handle, MU_DEBUG_TRACE6,("greylisting %s", email));
		*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
		MF_DATUM_PTR(contents) = (void*)&now;
		MF_DATUM_SIZE(contents) = sizeof now;
		if (mf_dbm_insert(&db, key, contents, 1))
			mu_error(_("Cannot insert datum `%-.*s' in greylist "
				   "database %s: %s"),
		                 MF_DATUM_SIZE(key), (char*)MF_DATUM_PTR(key),
				 greylist_format->dbname,
	                         mf_dbm_strerror());
		rc = 1;
	} else
		rc = 0;

	mf_dbm_close(&db);

	return rc;
}

/* Implementation of the is_greylisted predicate has no sense for 
   traditional greylist databases, because greylisting interval is
   not known beforehand.
   FIXME: keep the reference below up to date.
 */
static int
is_greylisted_traditional(eval_environ_t env, char *email)
{
		env_throw_bi(env, mfe_failure, NULL, _("is_greylisted is not implemented for traditional greylist databases; "
		   "see documentation, chapter %s %s for more info"),"4.12.1.23","Greylisting functions");
#line 586
	return 0;
}

/* New greylist implementation (by Con Tassios): the database keeps
   the time the greylisting period is set to expire (`interval' seconds
   from now)
*/
static int
do_greylist_ct(eval_environ_t env, char *email, long interval)
{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;
	int readonly;
	time_t now;

	rc = mf_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
        	if (!(rc == 0))
#line 605
			env_throw_bi(env, mfe_dbfailure, NULL, _("mf_dbm_open(%s) failed: %s"),greylist_format->dbname,mf_dbm_strerror())
;
	
	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(key) = email;
	MF_DATUM_SIZE(key) = strlen(email)+1;

	time(&now);
	if (mf_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp;

			if (!(MF_DATUM_SIZE(contents) == sizeof timestamp))
#line 617
			env_throw_bi(env, mfe_dbfailure, NULL, _("greylist database %s has wrong data size"),greylist_format->dbname)
#line 620
;
		
		timestamp = *(time_t*) MF_DATUM_PTR(contents);

		if (now < timestamp) {
			time_t diff = timestamp - now;
			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (diff);
			
			
#line 628

#line 628
mu_debug(debug_handle, MU_DEBUG_TRACE6,("%s still greylisted (for %lu sec.)",
			          email,
                                  (unsigned long) diff));
#line 632
			rc = 1;
		} else if (now - timestamp >
			   greylist_format->expire_interval) {
			
#line 635

#line 635
mu_debug(debug_handle, MU_DEBUG_TRACE6,("greylist record for %s expired", email));
#line 637
			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
			if (!readonly) {
				now += interval;
				memcpy(MF_DATUM_PTR(contents),
				       &now, sizeof now);
				if (mf_dbm_insert(&db, key, contents, 1))
					mu_error(_("Cannot insert datum "
						   "`%-.*s' in greylist "
						   "database %s: %s"),
			                         MF_DATUM_SIZE(key),
						 (char*)MF_DATUM_PTR(key),
						 greylist_format->dbname,
	                                         mf_dbm_strerror());
			} else
				
#line 651

#line 651
mu_debug(debug_handle, MU_DEBUG_TRACE6,("database opened in readonly mode: "
				          "not updating"));
#line 654
			rc = 1;
		} else {
			
#line 656

#line 656
mu_debug(debug_handle, MU_DEBUG_TRACE6,("%s finished greylisting period", email));
#line 658
			rc = 0;
		}
		mf_dbm_datum_free(&contents);
	} else if (!readonly) {
		
#line 662

#line 662
mu_debug(debug_handle, MU_DEBUG_TRACE6,("greylisting %s", email));
		*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
		now += interval;
		MF_DATUM_PTR(contents) = (void*)&now;
		MF_DATUM_SIZE(contents) = sizeof now;
		if (mf_dbm_insert(&db, key, contents, 1))
			mu_error(_("Cannot insert datum `%-.*s' in greylist "
				   "database %s: %s"),
		                 MF_DATUM_SIZE(key), (char*)MF_DATUM_PTR(key),
				 greylist_format->dbname,
	                         mf_dbm_strerror());
		rc = 1;
	} else
		rc = 0;
	
	mf_dbm_close(&db);
	
	return rc;
}

/* The `is_greylisted' predicate for new databases */
static int
is_greylisted_ct(eval_environ_t env, char *email)
{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;
	int readonly;
	time_t now;

	rc = mf_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
		if (!(rc == 0))
#line 695
			env_throw_bi(env, mfe_dbfailure, NULL, _("mf_dbm_open(%s) failed: %s"),greylist_format->dbname,mf_dbm_strerror())
;

	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(key) = email;
	MF_DATUM_SIZE(key) = strlen(email) + 1;

	time(&now);
	if (mf_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp;

			if (!(MF_DATUM_SIZE(contents) == sizeof timestamp))
#line 707
			env_throw_bi(env, mfe_dbfailure, NULL, _("greylist database %s has wrong data size"),greylist_format->dbname)
#line 710
;
                
		timestamp = *(time_t*) MF_DATUM_PTR(contents);
                
		rc = timestamp > now;
                if (rc)
			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (timestamp - now);

		mf_dbm_datum_free(&contents);
	} else  
		rc = 0;

	mf_dbm_close(&db);

	return rc;
}

struct greylist_class {
	int (*gl_fun)(eval_environ_t, char *, long);
	int (*gl_pred)(eval_environ_t, char *);
};

struct greylist_class greylist_class[] = {
	{ do_greylist_traditional, is_greylisted_traditional },
	{ do_greylist_ct, is_greylisted_ct }
};

/* greylist(key, interval)

   Returns true if the key is greylisted, false if it's OK to
   deliver mail.
 */
void
#line 742
bi_greylist(eval_environ_t env)
#line 742

#line 742 "db.bi"
{
#line 742
	
#line 742

#line 742

#line 742
char * email;
#line 742
        long  interval;
#line 742
        
#line 742
get_string_arg(env, 0, &email);
#line 742
        get_numeric_arg(env, 1, &interval);
#line 742
        
#line 742

#line 742
        adjust_stack(env, 2);
#line 742

#line 742
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 742
		prog_trace(env, "greylist %s %lu",email, interval);;
#line 742

{
	
#line 744
do {
#line 744
  push(env, (STKVAL) (greylist_class[greylist_semantics].gl_fun(env, email,
#line 744
							    interval)));
#line 744
  return;
#line 744
} while (0);
#line 746
}
}

/* is_greylisted(key)
   
   Returns true if the key is greylisted, otherwise false
   
*/
void
#line 754
bi_is_greylisted(eval_environ_t env)
#line 754

#line 754 "db.bi"
{
#line 754
	
#line 754

#line 754

#line 754
char * email;
#line 754
        
#line 754
get_string_arg(env, 0, &email);
#line 754
        
#line 754

#line 754
        adjust_stack(env, 1);
#line 754

#line 754
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 754
		prog_trace(env, "is_greylisted %s",email);;
#line 754

{
	
#line 756
do {
#line 756
  push(env, (STKVAL) (greylist_class[greylist_semantics].gl_pred(env, email)));
#line 756
  return;
#line 756
} while (0);
}
}

void
#line 760
bi_db_name(eval_environ_t env)
#line 760

#line 760 "db.bi"
{
#line 760
	
#line 760

#line 760

#line 760
char * fmtid;
#line 760
        
#line 760
get_string_arg(env, 0, &fmtid);
#line 760
        
#line 760

#line 760
        adjust_stack(env, 1);
#line 760

#line 760
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 760
		prog_trace(env, "db_name %s",fmtid);;
#line 760

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 763
			env_throw_bi(env, mfe_not_found, "db_name", _("no such db format: %s"),fmtid)
#line 765
;
	do {pushs(env, fmt->dbname);
#line 766
return;
#line 766
} while (0);
}
}

void
#line 770
bi_db_get_active(eval_environ_t env)
#line 770

#line 770 "db.bi"
{
#line 770
	
#line 770

#line 770

#line 770
char * fmtid;
#line 770
        
#line 770
get_string_arg(env, 0, &fmtid);
#line 770
        
#line 770

#line 770
        adjust_stack(env, 1);
#line 770

#line 770
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 770
		prog_trace(env, "db_get_active %s",fmtid);;
#line 770

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 773
			env_throw_bi(env, mfe_not_found, "db_get_active", _("no such db format: %s"),fmtid)
#line 775
;
	
#line 776
do {
#line 776
  push(env, (STKVAL) (fmt->enabled));
#line 776
  return;
#line 776
} while (0);
}
}

void
#line 780
bi_db_set_active(eval_environ_t env)
#line 780

#line 780 "db.bi"
{
#line 780
	
#line 780

#line 780

#line 780
char * fmtid;
#line 780
        long  active;
#line 780
        
#line 780
get_string_arg(env, 0, &fmtid);
#line 780
        get_numeric_arg(env, 1, &active);
#line 780
        
#line 780

#line 780
        adjust_stack(env, 2);
#line 780

#line 780
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 780
		prog_trace(env, "db_set_active %s %lu",fmtid, active);;
#line 780

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 783
			env_throw_bi(env, mfe_not_found, "db_set_active", _("no such db format: %s"),fmtid)
#line 785
;
	fmt->enabled = active;
}
}

void
#line 790
bi_db_expire_interval(eval_environ_t env)
#line 790

#line 790 "db.bi"
{
#line 790
	
#line 790

#line 790

#line 790
char * fmtid;
#line 790
        
#line 790
get_string_arg(env, 0, &fmtid);
#line 790
        
#line 790

#line 790
        adjust_stack(env, 1);
#line 790

#line 790
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 790
		prog_trace(env, "db_expire_interval %s",fmtid);;
#line 790

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 793
			env_throw_bi(env, mfe_not_found, "db_expire_interval", _("no such db format: %s"),fmtid)
#line 795
;
	
#line 796
do {
#line 796
  push(env, (STKVAL) (fmt->expire_interval));
#line 796
  return;
#line 796
} while (0);
}
}


#line 800
void
#line 800
db_init_builtin()
#line 800
{
#line 800
		debug_handle = mu_debug_register_category("bi_db");
#line 800

#line 800
	#line 70 "db.bi"

#line 70
install_pragma("dbprop", 3, 4, _pragma_dbprop);
#line 200 "db.bi"
va_builtin_install_ex("dbmap", bi_dbmap, 0, dtype_number, 3, 1, 0|0, dtype_string, dtype_string, dtype_number);
#line 210 "db.bi"
va_builtin_install_ex("dbget", bi_dbget, 0, dtype_string, 4, 2, 0|0, dtype_string, dtype_string, dtype_string, dtype_number);
#line 221 "db.bi"
va_builtin_install_ex("dbput", bi_dbput, 0, dtype_unspecified, 5, 2, 0|0, dtype_string, dtype_string, dtype_string, dtype_number, dtype_number);
#line 259 "db.bi"
va_builtin_install_ex("dbdel", bi_dbdel, 0, dtype_unspecified, 4, 2, 0|0, dtype_string, dtype_string, dtype_number, dtype_number);
#line 325 "db.bi"
DBTAB_id = builtin_priv_register(alloc_db_tab, destroy_db_tab,
#line 325
NULL);
#line 341 "db.bi"
va_builtin_install_ex("dbfirst", bi_dbfirst, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 369 "db.bi"
va_builtin_install_ex("dbnext", bi_dbnext, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 390 "db.bi"
va_builtin_install_ex("dbkey", bi_dbkey, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 408 "db.bi"
va_builtin_install_ex("dbvalue", bi_dbvalue, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 446 "db.bi"

#line 446
install_pragma("greylist", 2, 2, _pragma_greylist);
#line 472 "db.bi"
	builtin_variable_install("greylist_seconds_left", dtype_number, SYM_VOLATILE, &greylist_seconds_left_loc);
#line 742 "db.bi"
va_builtin_install_ex("greylist", bi_greylist, 0, dtype_number, 2, 0, 0|0, dtype_string, dtype_number);
#line 754 "db.bi"
va_builtin_install_ex("is_greylisted", bi_is_greylisted, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 760 "db.bi"
va_builtin_install_ex("db_name", bi_db_name, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 770 "db.bi"
va_builtin_install_ex("db_get_active", bi_db_get_active, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 780 "db.bi"
va_builtin_install_ex("db_set_active", bi_db_set_active, 0, dtype_unspecified, 2, 0, 0|0, dtype_string, dtype_number);
#line 790 "db.bi"
va_builtin_install_ex("db_expire_interval", bi_db_expire_interval, 0, dtype_number, 1, 0, 0|0, dtype_string);

#line 800 "db.bi"
	
#line 800
}
#line 800 "db.bi"

#line 800


#line 654 "../../src/builtin/snarf.m4"

#line 654

